import java.io.*;

public class ServerEssence implements Serializable {
  //
  private String host;
  //
  private int port;
  //
  private String adminUser;
  //
  private String adminPass;
  //
  private int numOfThread;
  //
  private long connectionTimeOut;


 /**
  *
  */
 public ServerEssence() {
  }

  /**
   *
   * @param host
   */
  public void setHost(String host) {
    this.host = host;
  }


  /**
   *
   * @return
   */
  public String getHost() {
    return host;
  }


  /**
   *
   * @param port
   */
  public void setPort(int port) {
    this.port = port;
  }


  /**
   *
   * @return
   */
  public int getPort() {
    return port;
  }


  /**
   *
   * @param adminUser
   */
  public void setAdminUser(String adminUser) {
    this.adminUser = adminUser;
  }


  /**
   *
   * @return
   */
  public String getAdminUser() {
    return adminUser;
  }


  /**
   *
   * @param adminPass
   */
  public void setAdminPass(String adminPass) {
    this.adminPass = adminPass;
  }


  /**
   *
   * @return
   */
  public String getAdminPass() {
    return adminPass;
  }


  /**
   *
   * @param numOfThread
   */
  public void setNumOfThread(int numOfThread) {
    this.numOfThread = numOfThread;
  }


  /**
   *
   * @return
   */
  public int getNumOfThread() {
    return numOfThread;
  }


  /**
   *
   * @param connectionTimeOut
   */
  public void setConnectionTimeOut(long connectionTimeOut) {
    this.connectionTimeOut = connectionTimeOut;
  }


  /**
   *
   * @return
   */
  public long getConnectionTimeOut() {
    return connectionTimeOut;
  }


  /**
   *
   * @return
   */
  private boolean isValid(){

   boolean hostOk = host != null&&host.length()>5;
   boolean portOk = port>0&&port<65536;
   boolean adminUserOk = adminUser!=null&&adminUser.length()>6;
   boolean adminPassOk = adminPass!=null&&adminPass.length()>6;
   boolean numOfThreadOk = numOfThread>0&&numOfThread<200;
   boolean conTimeOutOk = connectionTimeOut>0&&connectionTimeOut<(10*60*1000);

   boolean result = hostOk&&portOk&&
          adminUserOk&&adminPassOk&&
          numOfThreadOk&&conTimeOutOk;

   System.out.println("CONFIGURAZIONE VALIDA: "+result);
   return result;
  }


  /**
   *
   * @return
   */
  public Server getServerInstace(){
   if(isValid()) return new Server(this);
   return null;
  }



}//end